/*
 * ʬڥꥹȥƥȥץ
 */


#include<unistd.h>
#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<sys/stat.h>
#include<string.h>


typedef unsigned char uchar;
typedef unsigned long long uint64;


enum{
	DIGIT=2,				/* ͤɽ */
	MAX_NAME_SIZE=127,
	BLOCK_SIZE=4096
};

typedef struct DIR_ENT{
	uint secter;		/* secter number */
	uchar type;			/* File or directory */
	uchar size;			/* entry size */
	uchar low_dir;		/* low entry directory */
	uchar high_dir;		/* high entry directory */
	ushort low;			/* low entry offset */
	ushort high;		/* high entry offset */
	ushort low_num;		/* lowȥ꡼ */
	ushort high_num;	/* highȥ꡼ */
/****** ƥ *******/
	ushort x;
	ushort y;
	struct DIR_ENT *prev;
	struct DIR_ENT *next;
/*********************/
	char name[0];		/* Name string */
}DIR_ENT;

/* Directory empty entry */
typedef struct{
	ushort prev;	/* prev empty entry */
	ushort next;	/* next empty entry */
	int size;		/* entry size */
}EMPTY_ENT;

typedef struct{
	uint my_secter;			/* my block number */
	uint next_dir;			/* next directory link */
	ushort empty_prev;		/* empty entry offset */
	ushort empty_next;		/* empty entry offset */
	uchar entry_dir;		/* Top entry direcctory */
	ushort entry_top;		/* Top entry offset */
	ushort size;			/* directory size */
	ushort owner_id;		/* Owner UID */
	ushort group_id;		/* Group ID */
	uint64 access_time;		/* Last access time */
	uint64 create_time;		/* Create time */
	uint64 modificat_time;	/* Last modification time */
	DIR_ENT entry[0];		/* begin entry */
}DIR;

#define ENTRY(entry,buf) ((DIR_ENT*)(entry+(uint)buf))
#define EMPTY(empty,buf) ((EMPTY_ENT*)(empty+(uint)buf))
#define ROUNDUP(a,b) (((uint)(a)+(b)-1)/(b)*(b))

extern inline int cmp_path(const char *path1,const char *path2)
{
	char str1[3]={0,0,0};
	char str2[3]={0,0,0};
	int a,b;


	str1[0]=path1[0];
	str1[1]=path1[1];
	str2[0]=path2[0];
	str2[1]=path2[1];
	a=atoi(str1);
	b=atoi(str2);

	if(a<b)return 1;
	if(a>b)return -1;
	return 0;
}


/**********************************************************************************
 *
 * ʬؿ
 *
 **********************************************************************************/

void round_low(uchar *dn,ushort *entry,DIR **dir)
{
	uchar a;
	ushort b,c;
	DIR_ENT *top,*high;


	top=ENTRY(*entry,dir[*dn]);
	if((high=ENTRY(top->high,dir[top->high_dir]))==(DIR_ENT*)dir[0])return;

	/* topȥ꡼¸ */
	a=*dn;
	b=*entry;
	c=top->low_num+top->high_num;

	/* highȥ꡼topοƥȥ꡼λҥΡɤ˰ư */
	*entry=top->high;
	*dn=top->high_dir;

	/* highlowȥ꡼tophighȥ꡼˰ư */
	top->high_dir=high->low_dir;
	top->high=high->low;
	top->high_num=high->low_num;

	/* tophighlowȥ꡼˰ư */
	high->low_dir=a;
	high->low=b;
	high->low_num=c;
}

void round_high(uchar *dn,ushort *entry,DIR **dir)
{
	uchar a;
	ushort b,c;
	DIR_ENT *top,*low;


	top=ENTRY(*entry,dir[*dn]);
	if((low=ENTRY(top->low,dir[top->low_dir]))==(DIR_ENT*)dir[0])return;

	/* topȥ꡼¸ */
	a=*dn;
	b=*entry;
	c=top->low_num+top->high_num;

	/* highȥ꡼topοƥȥ꡼λҥΡɤ˰ư */
	*entry=top->low;
	*dn=top->low_dir;

	/* highlowȥ꡼tophighȥ꡼˰ư */
	top->low_dir=low->high_dir;
	top->low=low->high;
	top->low_num=low->high_num;

	/* tophighlowȥ꡼˰ư */
	low->high_dir=a;
	low->high=b;
	low->high_num=c;
}

void splay(uchar *dn,ushort *entry,DIR **dir)
{
	DIR_ENT *top;


	top=ENTRY(*entry,dir[*dn]);
	if((top->high_num>top->low_num*2)&&(ENTRY(top->high,dir[top->high_dir])->low_num<top->high_num/2))
		round_low(dn,entry,dir);
	else if((top->low_num>top->high_num*2)&&(ENTRY(top->low,dir[top->low_dir])->high_num<top->low_num/2))
		round_high(dn,entry,dir);
}

DIR_ENT *search_same_entry(const char **name,DIR **dir)
{
	int r;
	DIR_ENT *p;


	for(p=ENTRY(dir[0]->entry_top,dir[dir[0]->entry_dir]);p!=(DIR_ENT*)dir[0];)
	{
		r=cmp_path(p->name,*name);
		if(r<0)p=ENTRY(p->low,dir[p->low_dir]);
		else if(r>0)p=ENTRY(p->high,dir[p->high_dir]);
		else
		{
			*name=(const char*)r;
			return p;
		}
	}

	return NULL;
}

int search_prev_entry(const char *name,DIR **dir,uchar **dn,ushort **ent)
{
	uchar *ent_dir;
	ushort *entry;
	int r;
	DIR_ENT *p=NULL;


	for(ent_dir=&dir[0]->entry_dir,entry=&dir[0]->entry_top;*entry!=0;)
	{
		splay(ent_dir,entry,dir);
		p=ENTRY(*entry,dir[*ent_dir]);
		r=cmp_path(p->name,name);
		if(r<0)
		{
			++p->low_num;
			ent_dir=&p->low_dir;
			entry=&p->low;
		}
		else if(r>0)
		{
			++p->high_num;
			ent_dir=&p->high_dir;
			entry=&p->high;
		}
		else return -1;
	}

	*dn=ent_dir;
	*ent=entry;

	return 0;
}

DIR_ENT *get_empty_entry(int path_len,DIR **dir,uchar *dn,ushort *entry)
{
	enum{MIM_EMPTY_SIZE=sizeof(DIR_ENT)+sizeof(int)};		/* ȥ꡼ǺǾλĤ */

	int entry_len;
	uchar i;
	ushort k,last;
	EMPTY_ENT *p,*q;


	/* ̾Υǧ */
	if(path_len>MAX_NAME_SIZE)return NULL;

	entry_len=ROUNDUP(path_len+1,sizeof(int))+sizeof(DIR_ENT);

	/* ȥ꡼򸡺 */
	last=(uint)dir[0]->empty_prev-(uint)dir[0];
	for(i=0;dir[i]!=NULL;++i)
	{
		for(k=dir[i]->empty_next;k!=last;k=p->next)
		{
			p=EMPTY(k,dir[i]);
			if(p->size>entry_len)
			{
				if(p->size>entry_len+MIM_EMPTY_SIZE)
				{
					q=EMPTY(k+entry_len,dir[i]);
					q->prev=p->prev;
					q->next=p->next;
					EMPTY(q->prev,dir[i])->next+=entry_len;
					EMPTY(q->next,dir[i])->prev+=entry_len;
					q->size=p->size-entry_len;
					((DIR_ENT*)p)->size=entry_len;
				}
				else
				{
					EMPTY(p->prev,dir[i])->next=p->next;
					EMPTY(p->next,dir[i])->prev=p->prev;
					((DIR_ENT*)p)->size=p->size;
				}

				*dn=i;
				*entry=k;
				memset(p,0,sizeof(DIR_ENT));

				return (DIR_ENT*)p;
			}
		}
	}

	return NULL;
}

void add_empty_entry(ushort entry,DIR *dir)
{
	ushort i,last;
	EMPTY_ENT *p,*q;


	i=dir->empty_next;
	p=(EMPTY_ENT*)&dir->empty_prev;

	/* եåȽ˶ȥ꡼Υ󥯤õ */
	for(last=(uint)&dir->empty_prev-(uint)dir;i!=last;i=p->next)
	{
		p=EMPTY(i,dir);
		if(i>entry)
		{
			/* ϰϤ³Ƥз礹롣 */
			if(i+p->size==entry)
			{
				p->size+=ENTRY(entry,dir)->size;
				return;
			}
			else break;
		}
	}

	/* ȥ꡼󥯤˲ä롣 */
	q=EMPTY(entry,dir);
	q->size=((DIR_ENT*)q)->size;
	q->next=p->next;
	q->prev=(uint)p-(uint)dir;
	p->next=entry;
	EMPTY(q->next,dir)->prev=entry;
}

int add_entry(const char *name,DIR **dir)
{
	uchar *entry_dir;
	ushort *entry;
	int len;
	DIR_ENT *p;


	len=strlen(name);
	if(search_prev_entry(name,dir,&entry_dir,&entry)==-1)return -1;
	if((p=get_empty_entry(len,dir,entry_dir,entry))==NULL)return -1;
	memcpy(p->name,name,len+1);

	return 0;
}

int del_entry(const char *name,DIR **dir)
{
	uchar *ent_dir,i;
	ushort *entry,k;
	int r;
	DIR_ENT *p,*q;


	ent_dir=&dir[0]->entry_dir;
	entry=&dir[0]->entry_top;

	/* ȥ꡼򸡺롣 */
	for(;;)
	{
		if(*entry==0)return -1;

		p=ENTRY(*entry,dir[*ent_dir]);
		r=cmp_path(p->name,name);
		if(r<0)
		{
			--p->low_num;
			ent_dir=&p->low_dir;
			entry=&p->low;
		}
		else if(r>0)
		{
			--p->high_num;
			ent_dir=&p->high_dir;
			entry=&p->high;
		}
		else break;
	}

	/* ߤ롣 */
	while(p->low_num*p->high_num)
	{
		if(p->low_num<p->high_num)
		{
			round_low(ent_dir,entry,dir);
			q=ENTRY(*entry,dir[*ent_dir]);
			ent_dir=&q->low_dir;
			entry=&q->low;
		}
		else
		{
			round_high(ent_dir,entry,dir);
			q=ENTRY(*entry,dir[*ent_dir]);
			ent_dir=&q->high_dir;
			entry=&q->high;
		}
	}

	/*  */
	i=*ent_dir;
	k=*entry;
	*ent_dir=p->low_dir+p->high_dir;
	*entry=p->low+p->high;
	if(*entry!=dir[0]->entry_top)*(entry+2)=p->low_num+p->high_num;	/* DIR_ENT¤ΤǤ֤˰¸롣 */
	add_empty_entry(k,dir[i]);

	return 0;
}

void make_dir(DIR *dir,uint secter)
{
	EMPTY_ENT *empty;


	dir->my_secter=secter;
	dir->next_dir=0;
	dir->empty_prev=sizeof(DIR);
	dir->empty_next=sizeof(DIR);
	dir->entry_dir=0;
	dir->entry_top=0;
	dir->size=BLOCK_SIZE;
	dir->owner_id=0;		/* ̤ */
	dir->group_id=0;		/* ̤ */
	dir->access_time=0;		/* ̤ */
	dir->create_time=0;		/* ̤ */
	dir->modificat_time=0;	/* ̤ */

	/* ȥ꡼ꡣ */
	empty=(EMPTY_ENT*)dir->entry;
	empty->prev=(uint)&dir->empty_prev-(uint)dir;
	empty->next=empty->prev;
	empty->size=BLOCK_SIZE-sizeof(DIR);
}

/**********************************************************************************
 *
 * ƥؿ
 *
 **********************************************************************************/

void set_pos(DIR_ENT *entry,DIR_ENT *parent,DIR *dir,int comp)
{
	if(entry==(DIR_ENT*)dir)return;

	entry->x=parent->x*2+comp-1;
	entry->y=parent->y+1;
	set_pos(ENTRY(entry->low,dir),entry,dir,0);
	set_pos(ENTRY(entry->high,dir),entry,dir,1);
}

/* return : dst<src 1,dst>src -1,dst==src 0 */
int compare_pos(DIR_ENT *dst,DIR_ENT *src)
{
	if(dst->y<src->y)return 1;
	else if(dst->y>src->y)return -1;
	if(dst->x<src->x)return 1;
	else if(dst->x>src->x)return -1;
	return 0;
}

void sort_joint(DIR_ENT *root,DIR_ENT *entry,DIR *dir)
{
	DIR_ENT *p;


	if(entry==(DIR_ENT*)dir)return;

	p=root;
	do
	{
		if(compare_pos(p,entry)==-1)break;
		p=p->next;
	}while(p!=root);

	p->prev->next=entry;
	entry->prev=p->prev;
	p->prev=entry;
	entry->next=p;

	sort_joint(root,ENTRY(entry->low,dir),dir);
	sort_joint(root,ENTRY(entry->high,dir),dir);
}

void print_tree(DIR *dir)
{
	char *buf;
	int len,crt_y,crt_blk;
	DIR_ENT *root,*p;


	root=ENTRY(dir->entry_top,dir);
	root->prev=root;
	root->next=root;
	root->x=1;
	root->y=1;
	set_pos(ENTRY(root->low,dir),root,dir,0);
	set_pos(ENTRY(root->high,dir),root,dir,1);

	sort_joint(root,root,dir);

	len=DIGIT<<root->prev->y;
	crt_blk=1<<root->prev->y;
	if((buf=(char*)malloc(len))==NULL)return;
	memset(buf,' ',len);
	buf[len-1]='\0';
	root->prev->next=NULL;
	crt_y=1;
	for(p=root;p!=NULL;p=p->next)
	{
		if(p->y>crt_y)
		{
			printf("%s\n",buf);
			memset(buf,' ',len);
			buf[len-1]='\0';
			crt_blk>>=1;
			crt_y=p->y;
		}

		buf[p->x*DIGIT*crt_blk-(DIGIT*crt_blk/2)-DIGIT]=p->name[0];
		buf[p->x*DIGIT*crt_blk-(DIGIT*crt_blk/2)-DIGIT+1]=p->name[1];
	}
	printf("%s\n\n",buf);
}

int main(int argc,char *argv[])
{
	char str[16];
	DIR *dir;


	if((dir=(DIR*)malloc(BLOCK_SIZE))==NULL)
	{
		printf("꡼ݤ˼Ԥޤ\n");
		exit(0);
	}

	make_dir(dir,0);

	for(scanf("%s",str);*str!='q';scanf("%s",str))
	{
		if(*str=='a')
		{
			if(add_entry(&str[1],&dir)==-1)
				printf("Ǥˤ뤫ɲäǤޤ\n");
		}
		else if(*str=='d')
		{
			if(del_entry(&str[1],&dir)==-1)
				printf("Ĥޤ\n");
		}

		print_tree(dir);
	}

	exit(0);
}
